#!/usr/bin/python
import math

try:
    import xml.etree.cElementTree as ET
except ImportError:
    import xml.etree.ElementTree as ET

f1 = open('./gpscoords.h', 'w+')
tree = ET.parse("input.gpx")
root = tree.getroot()
#print ET.tostring(root)

print >>f1, "float lat[", len(root)/2, "];"
print >>f1, "float lon[", len(root)/2, "];"
print >>f1, "float hdg[", len(root)/2, "];"
print >>f1, "#define NUM_COORDS", len(root)/2

i=0
j=0
prev_lat = -1
prev_lon = -1

print >>f1, "void init_coords() {"

for child in root:
	if j==0:
		prev_lat = float(child.attrib.get('lat'))
		prev_lon = float(child.attrib.get('lon'))
		print >>f1, "lat[", i, "] =", prev_lat, ";"
		print >>f1, "lon[", i, "] =", prev_lon, ";"
	else:
		cur_lat = float(child.attrib.get('lat'))
		cur_lon = float(child.attrib.get('lon'))
		heading = math.atan2((prev_lon-cur_lon) , (prev_lat-cur_lat))	
		heading = (heading * 180/math.pi + 180) % 360
		print >>f1, "hdg[", i, "] =", heading, ";"
		i += 1

	j = (j+1)%2

print >>f1, "}"